PopUpMenu2 {
	
	// creates a PopUpMenu that will show a StaticText when enabled_( false )
	
	var <composite, <popUpMenu, <staticText;
	var <>action, <enabled = true;
	
	*new { |parent, bounds|
		^super.new.init(parent, bounds);
	}
	
	init { |parent, bounds|
		
		composite = CompositeView( parent, bounds );
		
		staticText = StaticText( composite, bounds.asRect.moveTo(10,0).width_(bounds.width - 10) )
			.resize_(5) // resize together with composite
			.align_( \left ) // LoopToys mod.
			.visible_( false );
		
		popUpMenu = PopUpMenu( composite, bounds.asRect.moveTo(0,0) )
			.resize_(5)
			.action_({
				this.updateString;
				action.value( this );
			});
			
	}
	
	updateString { staticText.string = (popUpMenu.items[ popUpMenu.value ] ? "").asString; }
	
	enabled_ { |bool| 
		enabled = bool;
		popUpMenu.visible_( enabled ); staticText.visible_( enabled.not );
	}
	
	// methods for PopUpMenu
	value { ^popUpMenu.value }
	value_ { |newVal| popUpMenu.value = newVal; this.updateString }
	items_ { |newItems| popUpMenu.items = newItems; this.updateString }
	
	// methods for PopUpMenu and StaticText
	font_ { |newFont| popUpMenu.font = newFont; staticText.font = newFont; }
	stringColor_ { |color| popUpMenu.stringColor = color; staticText.stringColor = color; }

	// methods for CompositeView
	resize_ { |resize| composite.resize = resize; }
	resize { ^composite.resize }
	
	visible_ { |bool| composite.visible_( bool ) }
	visible { ^composite.visible }
	
	bounds_ { |bounds| composite.bounds_( bounds ) }
	bounds { ^composite.bounds }
	
	background_ { |color| composite.background_( color ); }
	background { ^composite.background }
	
	remove { composite.remove; }
	parent { ^composite.parent; }
	
	// all other methods
	doesNotUnderstand { |selector ... args|
		var res;
		res = popUpMenu.perform( selector, *args );
		if( res == popUpMenu )
			{ ^this }
			{ ^res };
	}
}
